PROGRAM timemark;

CONST
	fw	= 11;
	initn	= 0;
	resetn	= 1;
	startn	= 2;
	shown	= 3;
	stopn	= 4;
	filename = 'timemark.log';

TYPE
	string11 = packed array [1..11] of char;
	timeptr = ^timelist;
	timelist = record
		baseaddr : integer;
		ptime : string11;
		etime : string11;
		atime : string11;
		data : array [1..6] of integer;
		end;

VAR
	timedata : timeptr;
	logfile	: text;

{***********************************************************************}

{ External procedure in 8086 assembly language, see DOTIME.ASM }

PROCEDURE dotime(procno:byte; dataptr:timeptr); external 'dotime.com';

{***********************************************************************}

PROCEDURE init_timer;

BEGIN
	new(timedata);
	timedata^.baseaddr := ofs(dotime);
	dotime(initn,timedata);
END;

{***********************************************************************}

PROCEDURE mark_time;

BEGIN
	write(output,'Time: ',timedata^.ptime:fw);
	write(logfile,'Time: ',timedata^.ptime:fw);
	write(output,', Elapsed: ',timedata^.etime:fw);
	write(logfile,', Elapsed: ',timedata^.etime:fw);
	write(output,', Accumulated: ',timedata^.atime:fw);
	write(logfile,', Accumulated: ',timedata^.atime:fw);
END;

{***********************************************************************}

PROCEDURE reset_timer;

BEGIN
	dotime(resetn,timedata);
	mark_time;
	writeln(output,' RESET');
	writeln(logfile,' RESET');
END;

{***********************************************************************}

PROCEDURE start_timer;

BEGIN
	dotime(startn,timedata);
	mark_time;	
	writeln(output,' START');
	writeln(logfile,' START');
END;

{***********************************************************************}

PROCEDURE show_timer;

BEGIN
	dotime(shown,timedata);
	mark_time;	
	writeln(output,' SHOW');
	writeln(logfile,' SHOW');
END;

{***********************************************************************}

PROCEDURE stop_timer;
	
BEGIN
	dotime(stopn,timedata);	
	mark_time;
	writeln(output,' STOP');
	writeln(logfile,' STOP');
END;

{***********************************************************************}

PROCEDURE pausing(max: integer);

VAR
	i,j : integer;

BEGIN
	writeln(output,'Doing something ....');
	writeln(logfile,'Doing something ....');
	FOR j:= 0 TO max DO
		FOR i:= 0 TO 32000 DO;
END;

{***********************************************************************}

BEGIN {main}
	Assign(logfile,filename);
	Rewrite(logfile);
	init_timer;
	reset_timer;
	pausing(60);
	show_timer;
	pausing(50);
	show_timer;
	pausing(35);
	stop_timer;
	pausing(10);
	show_timer;
	pausing(37);
	start_timer;
	pausing(10);
	stop_timer;
	Reset(logfile);
END.
